"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var ScanditSDK = _interopRequireWildcard(require("scandit-sdk"));

var _pickerWrapper = _interopRequireDefault(require("./picker-wrapper"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Scanner = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Scanner, _Component);

  function Scanner() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "picker", new _pickerWrapper["default"]());

    _defineProperty(_assertThisInitialized(_this), "scannerContainerRef", _react["default"].createRef());

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      _this.configureLibrary().then(function () {
        return _this.initializePicker();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "componentWillUnmount", function () {
      if (_this.picker) {
        _this.picker.destroy();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      _this.updatePicker(prevProps);
    });

    _defineProperty(_assertThisInitialized(_this), "configureLibrary", function () {
      return ScanditSDK.configure(_this.props.licenseKey, {
        engineLocation: _this.props.engineLocation,
        preloadBlurryRecognition: _this.props.preloadBlurryRecognition,
        preloadEngine: _this.props.preloadEngine
      });
    });

    _defineProperty(_assertThisInitialized(_this), "initializePicker", function () {
      _this.picker.initialize(_this.scannerContainerRef.current, _this.props);
    });

    _defineProperty(_assertThisInitialized(_this), "updatePicker", function (prevProps) {
      _this.picker != null && _this.picker.update(prevProps, _this.props);
    });

    return _this;
  }

  var _proto = Scanner.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      ref: this.scannerContainerRef
    });
  };

  return Scanner;
}(_react.Component);

Scanner.propTypes = process.env.NODE_ENV !== "production" ? {
  licenseKey: _propTypes["default"].string.isRequired,
  engineLocation: _propTypes["default"].string.isRequired,
  preloadBlurryRecognition: _propTypes["default"].bool,
  preloadEngine: _propTypes["default"].bool,
  accessCamera: _propTypes["default"].bool,
  camera: _propTypes["default"].object,
  cameraSettings: _propTypes["default"].object,
  cameraType: _propTypes["default"].any,
  enableCameraSwitcher: _propTypes["default"].bool,
  enablePinchToZoom: _propTypes["default"].bool,
  enableTapToFocus: _propTypes["default"].bool,
  enableTorchToggle: _propTypes["default"].bool,
  guiStyle: _propTypes["default"].any,
  laserArea: _propTypes["default"].any,
  mirrorImage: _propTypes["default"].bool,
  paused: _propTypes["default"].bool,
  playSoundOnScan: _propTypes["default"].bool,
  scanSettings: _propTypes["default"].object,
  singleImageModeSettings: _propTypes["default"].object,
  targetScanningFPS: _propTypes["default"].number,
  vibrateOnScan: _propTypes["default"].bool,
  videoFit: _propTypes["default"].any,
  visible: _propTypes["default"].bool,
  viewfinderArea: _propTypes["default"].any,
  zoom: _propTypes["default"].number,
  onReady: _propTypes["default"].func,
  onScan: _propTypes["default"].func,
  onScanError: _propTypes["default"].func,
  onProcessFrame: _propTypes["default"].func,
  onSubmitFrame: _propTypes["default"].func
} : {};
var _default = Scanner;
exports["default"] = _default;
module.exports = exports.default;